/*
 ============================================================================
 Name        : RectangleStructs.c
 Author      : (your name)
 Version     :
 Description : Rectangle test harness
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "rectangle.h"

/**************************************************************************
 *   DO NOT MODIFY THE CODE IN THIS FILE
 * Implement your solutions in rectangle.h and rectangle.c.
 *   DO NOT MODIFY THE CODE IN THIS FILE
 *************************************************************************/
/**************************************************************************
 * Testing helper functions
 *************************************************************************/
void printTestHeader(char *testName) {
	int i;
	printf("\n\n");
	for (i=0; i<REPORT_WIDTH; i++)
		putchar('-');
	putchar('\n');
	printf("Testing ");
	printf("%s", testName);
	printf(":\n");
	for (i=0; i<REPORT_WIDTH; i++)
		putchar('-');
	putchar('\n');
}

void printTestFooter(char *label, int passed, int tested) {
	int barLen = REPORT_WIDTH - strlen(label) - 17;
	int i;
	for (i=0; i<barLen; i++)
		putchar('=');

	printf("> %s result: %5.1f%%\n", label, 100.0 * passed / tested);
}

void testAccessor(char *label, int actual, int expected, int *pc, int *tc) {
	(*tc)++;
	if (actual == expected) {
		(*pc)++;
		printf("test case passed %s\n", label);
	} else {
			printf("TEST CASE DID NOT PASS '%s', expected %d, got %d\n", label,
						expected, actual);
	}
}

void testAreIntersectingTrue(char *rLabel, char *sLabel,
								Rectangle r, Rectangle s,
								int *pc, int *tc) {
	(*tc)++;
	if (areIntersecting(r, s)) {
		(*pc)++;
		printf("test case passed %s and %s\n", rLabel, sLabel);
	} else {
		printf("TEST CASE DID NOT PASS %s and %s\n", rLabel, sLabel);
	}
}

void testAreIntersectingFalse(char *rLabel, char *sLabel,
								Rectangle r, Rectangle s,
								int *pc, int *tc) {
	(*tc)++;
	if (areIntersecting(r, s)) {
		printf("TEST CASE DID NOT PASS %s and %s\n", rLabel, sLabel);
	} else {
		(*pc)++;
		printf("test case passed %s and %s\n", rLabel, sLabel);
	}
}

void testEqualRect(boolean structOK, char *label, Rectangle r, Rectangle s, int *pc, int *tc) {
	(*tc)++;
	int areEqual = getTop(r) == getTop(s) && getLeft(r) == getLeft(s)
			&& getBottom(r) == getBottom(s) && getRight(r) == getRight(s);
	if (structOK && areEqual) {
		(*pc)++;
		printf("test case passed %s\n", label);
	} else {
		printf("TEST CASE DID NOT PASS %s\n", label);
	}
}

int main() {

	/* Question 4a:  Testing function makeRect */
	printTestHeader("makeRect()");
	printf("\nRECALL: r1, r2, r3, and r4 are from the figure given.\n\n");
	printf("Making r1\n");
	Rectangle r1 = makeRect(-3, 3, 5, -2);
	printf("Making r2\n");
	Rectangle r2 = makeRect(6, 1, 2, 8);
	printf("Making r3\n");
	Rectangle r3 = makeRect(10, 7, 6, 4);
	printf("Making r4\n");
	Rectangle r4 = makeRect(2, 1, 5, 3);

	int passed, tested;

	/* Question 4b:  Testing function getLeft */
	printTestHeader("getLeft()");
	printf("\nRECALL: r1, r2, r3, and r4 are from the figure given.\n\n");
	passed = 0;
	tested = 0;
	testAccessor("r1", getLeft(r1), -3, &passed, &tested);
	testAccessor("r2", getLeft(r2), 2, &passed, &tested);
	testAccessor("r3", getLeft(r3), 6, &passed, &tested);
	testAccessor("r4", getLeft(r4), 2, &passed, &tested);
	printTestFooter("getLeft()", passed, tested);

	/* Question 4c:  Testing function getRight */
	printTestHeader("getRight()");
	printf("\nRECALL: r1, r2, r3, and r4 are from the figure given.\n\n");
	passed = 0;
	tested = 0;
	testAccessor("r1", getRight(r1), 5, &passed, &tested);
	testAccessor("r2", getRight(r2), 6, &passed, &tested);
	testAccessor("r3", getRight(r3), 10, &passed, &tested);
	testAccessor("r4", getRight(r4), 5, &passed, &tested);
	printTestFooter("getRight()", passed, tested);

	/* Question 4d:  Testing function getTop */
	printTestHeader("getTop()");
	printf("\nRECALL: r1, r2, r3, and r4 are from the figure given.\n\n");
	passed = 0;
	tested = 0;
	testAccessor("r1", getTop(r1), 3, &passed, &tested);
	testAccessor("r2", getTop(r2), 8, &passed, &tested);
	testAccessor("r3", getTop(r3), 7, &passed, &tested);
	testAccessor("r4", getTop(r4), 3, &passed, &tested);
	printTestFooter("getTop()", passed, tested);

	/* Question 4e:  Testing function getBottom */
	printTestHeader("getBottom()");
	printf("\nRECALL: r1, r2, r3, and r4 are from the figure given.\n\n");
	passed = 0;
	tested = 0;
	testAccessor("r1", getBottom(r1), -2, &passed, &tested);
	testAccessor("r2", getBottom(r2), 1, &passed, &tested);
	testAccessor("r3", getBottom(r3), 4, &passed, &tested);
	testAccessor("r4", getBottom(r4), 1, &passed, &tested);
	printTestFooter("getBottom()", passed, tested);

	/* Question 4f:  Testing function areIntersecting */
	printTestHeader("areIntersecting()");
	printf("\nRECALL: r1, r2, r3, and r4 are from the figure given.\n\n");
	passed = 0;
	tested = 0;
	testAreIntersectingTrue("r1", "r2", r1, r2, &passed, &tested);
	testAreIntersectingTrue("r2", "r1", r2, r1, &passed, &tested);
	testAreIntersectingFalse("r1", "r3", r1, r3, &passed, &tested);
	testAreIntersectingFalse("r3", "r1", r3, r1, &passed, &tested);
	testAreIntersectingTrue("r1", "r4", r1, r4, &passed, &tested);
	testAreIntersectingTrue("r4", "r1", r4, r1, &passed, &tested);
	testAreIntersectingTrue("r2", "r3", r2, r3, &passed, &tested);
	testAreIntersectingTrue("r3", "r2", r3, r2, &passed, &tested);
	testAreIntersectingTrue("r2", "r4", r2, r4, &passed, &tested);
	testAreIntersectingTrue("r4", "r2", r4, r2, &passed, &tested);
	testAreIntersectingFalse("r3", "r4", r3, r4, &passed, &tested);
	testAreIntersectingFalse("r4", "r3", r4, r3, &passed, &tested);
	printTestFooter("areIntersecting()", passed, tested);

	/* Question 4g:  Testing function intersect */
	printTestHeader("intersect()");
	printf("Creating intersecting rectangles\n");
	Rectangle r12 = intersect(r1, r2);
	Rectangle r21 = intersect(r2, r1);
	Rectangle r14 = intersect(r1, r4);
	Rectangle r41 = intersect(r4, r1);
	Rectangle r23 = intersect(r2, r3);
	Rectangle r32 = intersect(r3, r2);
	Rectangle r24 = intersect(r2, r4);
	Rectangle r42 = intersect(r4, r2);

	printf("Testing intersection results\n");
	printf("\nRECALL: r1, r2, r3, and r4 are from the figure given.\n\n");
	passed = 0;
	tested = 0;
	Rectangle line = makeRect(6,4,6,7);
	boolean structOK = getLeft(line) == 6 && getRight(line) == 6 && getTop(line) == 4 && getBottom(line) == 7;
	testEqualRect(structOK, "intersect(r1, r2)", r12, r4, &passed, &tested);
	testEqualRect(structOK, "intersect(r2, r1)", r21, r4, &passed, &tested);
	testEqualRect(structOK, "intersect(r1, r4)", r14, r4, &passed, &tested);
	testEqualRect(structOK, "intersect(r4, r1)", r41, r4, &passed, &tested);
	testEqualRect(structOK, "intersect(r2, r3)", r23, line, &passed, &tested);
	testEqualRect(structOK, "intersect(r3, r2)", r32, line, &passed, &tested);
	testEqualRect(structOK, "intersect(r2, r4)", r24, r4, &passed, &tested);
	testEqualRect(structOK, "intersect(r4, r2)", r42, r4, &passed, &tested);
	printTestFooter("intersect()", passed, tested);

	return 0;
}
