/*
 ============================================================================
 Name        : rectangle.h
 Author      : (your name)
 Description : Rectangle module to create and examine rectangles
 ============================================================================
 */

#ifndef RECTANGLE_H_
#define RECTANGLE_H_

#define REPORT_WIDTH 60

/* Define the constants true and false*/
#define FALSE 0
#define TRUE 1

/* Define our own boolean type */
typedef int boolean;

/* Define a point struct type */
typedef struct {
   int x;
   int y;
} Point;

/**************************************************************************
 * YOUR CODE BEGINS HERE -- YOUR CODE BEGINS HERE -- YOUR CODE BEGINS HERE
 *************************************************************************/

 /* Define a Rectangle struct type */
typedef struct {
	// TODO: Fill in this struct
} Rectangle;

/**************************************************************************
 * YOUR CODE ENDS HERE -- YOUR CODE ENDS HERE -- YOUR CODE ENDS HERE
 *************************************************************************/

/**************************************************************************
 * Function prototypes
 *************************************************************************/

 /* Makes a point from the given coordinates. */
Point makePoint(int x, int y);

/* Makes a rectangle from the given coordinates.  A rectangle is made up of
 * two points. */
Rectangle makeRect(int x1, int y1, int x2, int y2);

/* Returns the x-coordinate of the left-most edge of the given rectangle. */
int getLeft(Rectangle r);

/* Returns the x-coordinate of the right-most edge of the given rectangle. */
int getRight(Rectangle r);

/* Returns the y-coordinate of the top-most edge of the given rectangle. */
int getTop(Rectangle r);

/* Returns the y-coordinate of the bottom-most edge of the given rectangle. */
int getBottom(Rectangle r);

/* Returns TRUE if the given rectangles touch and FALSE if they do not touch. */
boolean areIntersecting(Rectangle q, Rectangle r);

/* Returns a new rectangle representing the overlapping area of the two given
 * rectangles.  */
Rectangle intersect(Rectangle q, Rectangle r);

#endif /*RECTANGLE_H_*/
